package oko.tm.oko_s2;

import android.app.ActivityManager;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.res.AssetFileDescriptor;
import android.media.MediaPlayer;
import android.os.Handler;
import android.os.Message;
import android.support.v4.content.LocalBroadcastManager;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.telephony.SmsManager;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ImageButton;
import android.widget.ImageView;

import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.content.SharedPreferences;

import java.math.BigInteger;
import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;




public class MainActivity extends ActionBarActivity {

    public static Context mContext;

    public static boolean Service_Restart=false;
    public static volatile boolean Client_Thread_stop=false;
    public static volatile boolean Periodic_Thread_stop=false;
    //public static boolean Activity_Start=false;
    //----- для создания служебного лога
    public static final String TAG = "myLogs";

    // это будет именем файла настроек,данных
    public static final String APP_PREFERENCES = "oko_s2_settings";
    // переменная для работы с файлом
    static SharedPreferences mSettings;

    // настройки, подлежащие хранению
    public static final String APP_PREFERENCES_PHONE = "phone";
    public static final String APP_PREFERENCES_PASSWORD = "password";
    public static final String APP_PREFERENCES_IMEI = "imei";
    public static final String APP_PREFERENCES_QUERY = "query";
    public static final String APP_PREFERENCES_POWER = "power";
    public static final String APP_PREFERENCES_ARM = "arm";
    public static final String APP_PREFERENCES_GSM = "gsm";
    public static final String APP_PREFERENCES_INPUT = "input";
    public static final String APP_PREFERENCES_RELE = "rele";

    public static final String APP_PREFERENCES_CONNECTION = "connection";
    public static final String APP_PREFERENCES_SERVICE = "service";

    public static final String APP_PREFERENCES_CHECK_BOX_QUERY = "checkBox_query";
    public static final String APP_PREFERENCES_IMAGE_VIEW_POWER = "imageView_power";
    public static final String APP_PREFERENCES_IMAGE_VIEW_ARM = "imageView_arm";
    public static final String APP_PREFERENCES_IMAGE_VIEW_GSM = "imageView_GSM";
    public static final String APP_PREFERENCES_IMAGE_VIEW_INPUT = "imageView_input";


    // --- телефонный номер розетки
    public String PHONE_NUMBER = "";
    // --- пароль управления розеткой
    public static String PASSWORD = "";
    //IMEI
    public static String IMEI = "";

    //---------------------- Выпадающий список способа управления
    String Connection_1="через SMS";
    String Connection_2="через Интернет";

    //---------------------- Выпадающий список смс-команд
    String Command_1="ВКЛЮЧИТЬ ВЫХОД";
    String Command_2="Выключить ВЫХОД";
    String Command_3="Запрос настроек прибора";

    String SMS_Command_1="06"; //;"OHRANA OFF,220V ON,VXOD TREVOGA,RELE OFF,GSM: SREDNIJ"
    String SMS_Command_2="05"; //;"OHRANA ON,220V OFF,VXOD NORMA,RELE ON,GSM: VYSOKIJ"
    String SMS_Command_3="08"; //; "OHRANA OFF,220V OFF,RAZRYAD AKKUM,VXOD TREVOGA,RELE ON,GSM: NIZKIJ"

    public int COMMAND_POSITION = 0;
    public static int CONNECTION_POSITION=0;
    public static Integer ccc=0;
//----------------------------------------------------------



    //----- перевод сообщений от розетки на кирилицу
    public static final String SMS_220V_ON = "220V ON";
    public static final String EST = "ЕСТЬ";
    public static final String SMS_220V_OFF = "220V OFF";
    public static final String NET = "НЕТ";

     public static final String SMS_ARM_ON = "OHRANA ON";
    public static final String VKL = "ВКЛЮЧЕНА";
    public static final String SMS_ARM_OFF = "OHRANA OFF";
    public static final String VYKL = "ВЫКЛЮЧЕНА";
    public static final String SMS_ZONA_NORMA = "VXOD NORMA";
    public static final String NORMA = "НОРМА";
    public static final String SMS_ZONA_TREVOGA = "VXOD TREVOGA";
    public static final String TREVOGA = "ТРЕВОГА";
    public static final String SMS_GSM_LEVEL_HIGH = "VYSOKIJ";
    public static final String VYSOKIJ = "ВЫСОКИЙ";
    public static final String SMS_GSM_LEVEL_MEDIUN = "SREDNIJ";
    public static final String SREDNIJ = "СРЕДНИЙ";
    public static final String SMS_GSM_LEVEL_LOW = "NIZKIJ";
    public static final String NIZKIJ = "НИЗКИЙ";

    public static final String SMS_ACC_LOW = "RAZRYAD AKKUM";
    public static final String ACC_LOW = "РАЗРЯД АКБ";

    public static final String SMS_RELE_ON = "RELE ON";
    public static final String RELE_VKL = "ВКЛЮЧЕН";
    public static final String SMS_RELE_OFF = "RELE OFF";
    public static final String RELE_VYKL = "ВЫКЛЮЧЕН";

    public static final int COLOR_WHITE=0xffffffff ;
    public static final int COLOR_RED=0xffffaaaa ;
    public static final int COLOR_GREEN=0xffaaffaa ;
    public static final int COLOR_YELLOW=0xaaffff66 ;

    // --- элементы отображения и управления
    Button btn_restart_connection;
    Button btn_send_command;
    CheckBox checkBox_query;
    static TextView textView_query;
    static TextView textView_power;
    static TextView textView_arm;
    static TextView textView_gsm;
    static TextView textView_input;
    static TextView textView_rele;



    ImageButton imageButton_ON;
    ImageButton imageButton_OFF;
    ImageButton imageButton_Query;

    static ImageView imageView_power_on;
    static ImageView imageView_power_off;
    static ImageView imageView_power_;
    static ImageView imageView_arm_on;
    static ImageView imageView_arm_off;
    static ImageView imageView_arm_;
    static ImageView imageView_GSM_high;
    static ImageView imageView_GSM_medium;
    static ImageView imageView_GSM_low;
    static ImageView imageView_GSM_;
    static ImageView imageView_input_norma;
    static ImageView imageView_input_trevoga;
    static ImageView imageView_input_;


    String Enter_Phone_Password = "Введите телефонный номер OKO-S2 и пароль доступа";
    String Enter_Phone = "Введите телефонный номер OKO-S2";
    String Enter_Password = "Введите пароль доступа OKO-S2";
    String Enter_IMEI = "Введите IMEI прибора OKO-S2";
    String Enter_IMEI_Password = "Введите IMEI прибора OKO-S2 и пароль доступа";

    // ------- команды
    static String Query_server = "70";
    String ini_password = "1234";
    String Arm_on = "01";
    String Arm_off = "00";
    String Query = "02";

    // ---- надписи на главном окне
    static String update_time = "Обновление: ";
    static String state_220v = "Наличие 220В: ";
    static String state_arm = "Охрана: ";
    static String gsm_level = "Уровень GSM: ";
    static String state_vxod = "Датчик: ";
    static String state_rele = "Выход: ";

    //для широковещательного приемника, настроенного на прием данных с сервиса
    BroadcastReceiver br_tcp;
    BroadcastReceiver br_sms;


    /**
     * Called when the activity is first created.
     */
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mContext = this;


        //
        // Possible work around for market launches. See http://code.google.com/p/android/issues/detail?id=2373
        // for more details. Essentially, the market launches the main activity on top of other activities.
        // we never want this to happen. Instead, we check if we are the root and if not, we finish.
        if (!isTaskRoot()) {
            final Intent intent = getIntent();
            if (intent.hasCategory(Intent.CATEGORY_LAUNCHER) && Intent.ACTION_MAIN.equals(intent.getAction())) {
                Log.d(TAG, "Main Activity is not the root.  Finishing Main Activity instead of launching.");
                finish();
                return;
            }
        }


        Log.d(TAG, "MainActivity Create");


        ClientThread.MainActivity_Started=false;
        SmsReceiver.MainActivity_Started=false;

        // создаем BroadcastReceiver для приема данных с сервиса
        br_tcp = new BroadcastReceiver() {
            // действия при получении сообщений
            public void onReceive(Context context, Intent intent) {

                //int type = intent.getIntExtra(PARAM_TYPE, 0);
                //int data = intent.getIntExtra(PARAM_DATA, 0);
                String type = intent.getStringExtra(ClientThread.PARAM_TYPE);
                String data = intent.getStringExtra(ClientThread.PARAM_DATA);
                Log.d(TAG, "onReceive: type = " + type + ", data = " + data);
                // Ловим сообщения о наличии связи
                if (ClientThread.STATUS_CONNECTION.equals(type)) {

                    switch (data) {
                        case ClientThread.CONNECT_NO:
                            btn_restart_connection.setBackgroundColor(COLOR_RED);
                            break;
                        case ClientThread.CONNECT_TO_SERVER:
                            btn_restart_connection.setBackgroundColor(COLOR_YELLOW);
                            break;
                        case ClientThread.CONNECT_TO_DEVISE:
                            btn_restart_connection.setBackgroundColor(COLOR_GREEN);
                            break;

                    }
                }

                // Ловим сообщения от прибора
                if (ClientThread.DEVICE_DATA.equals(type)) {
                    //if (data.startsWith("{"))
                    //{
                    DoParsing(data);
                    //}
                }

            }
        };
        // создаем фильтр для BroadcastReceiver
        IntentFilter intFilt = new IntentFilter(ClientThread.TCP_BROADCAST_ACTION);
        // регистрируем (включаем) BroadcastReceiver
        //registerReceiver(br_tcp, intFilt);
        /*The LocalBroadcastManager class is a helper class to register local broadcast receivers as well
        as send broadcasts of Intents to them within our own app’s process rather than sending global broadcasts
        using sendBroadcast() as we saw before. It is more efficient as well as secured compared to global broadcasts
        through the system as the data won’t leave our app nor can we receive from other foreign apps.*/
        LocalBroadcastManager.getInstance(mContext).registerReceiver(br_tcp, intFilt);


        // создаем BroadcastReceiver для приема данных с sms_receiver (вариант через broadcast)
        br_sms = new BroadcastReceiver() {
            // действия при получении сообщений
            public void onReceive(Context context, Intent intent) {

                String message_text = intent.getStringExtra("message");
                String sender = intent.getStringExtra("sender");
                Log.d(TAG, "SMS_onReceive: sender = " + sender + ", message = " + message_text);
                sms_anal(message_text, sender);
            }
        };
        // создаем фильтр для BroadcastReceiver
        IntentFilter intFilt_sms = new IntentFilter(SmsReceiver.SMS_BROADCAST_ACTION);
        // регистрируем (включаем) BroadcastReceiver
        //registerReceiver(br_sms, intFilt_sms);
        /*The LocalBroadcastManager class is a helper class to register local broadcast receivers as well
        as send broadcasts of Intents to them within our own app’s process rather than sending global broadcasts
        using sendBroadcast() as we saw before. It is more efficient as well as secured compared to global broadcasts
        through the system as the data won’t leave our app nor can we receive from other foreign apps.*/
        LocalBroadcastManager.getInstance(mContext).registerReceiver(br_sms, intFilt_sms);


        //----------- работа с файлом, содержащий настройки
        mSettings = getSharedPreferences(APP_PREFERENCES, mContext.MODE_PRIVATE);
        btn_restart_connection= (Button) findViewById(R.id.btn_restart_connection);
        btn_send_command= (Button) findViewById(R.id.btn_send_command);
        checkBox_query = (CheckBox) findViewById(R.id.checkBox_query);
        imageButton_ON = (ImageButton) findViewById(R.id.imageButton_ON);
        imageButton_OFF = (ImageButton) findViewById(R.id.imageButton_OFF);
        imageButton_Query = (ImageButton) findViewById(R.id.imageButton_Query);
        imageView_power_off = (ImageView) findViewById(R.id.imageView_power_off);
        imageView_power_on = (ImageView) findViewById(R.id.imageView_power_on);
        imageView_power_ = (ImageView) findViewById(R.id.imageView_power_);
        imageView_arm_off = (ImageView) findViewById(R.id.imageView_arm_off);
        imageView_arm_on = (ImageView) findViewById(R.id.imageView_arm_on);
        imageView_arm_ = (ImageView) findViewById(R.id.imageView_arm_);
        imageView_GSM_high = (ImageView) findViewById(R.id.imageView_GSM_high);
        imageView_GSM_medium = (ImageView) findViewById(R.id.imageView_GSM_medium);
        imageView_GSM_low = (ImageView) findViewById(R.id.imageView_GSM_low);
        imageView_GSM_ = (ImageView) findViewById(R.id.imageView_GSM_);
        imageView_input_norma = (ImageView) findViewById(R.id.imageView_input_norma);
        imageView_input_trevoga = (ImageView) findViewById(R.id.imageView_input_trevoga);
        imageView_input_ = (ImageView) findViewById(R.id.imageView_input_);

        textView_query = (TextView) findViewById(R.id.textView_query);
        textView_power = (TextView) findViewById(R.id.textView_power);
        textView_arm = (TextView) findViewById(R.id.textView_arm);
        textView_gsm = (TextView) findViewById(R.id.textView_gsm);
        textView_input = (TextView) findViewById(R.id.textView_input);
        textView_rele = (TextView) findViewById(R.id.textView_rele);


        //------------- обратотка входящей смс от SmsReceiver (вариант рестарта Activity)
        Intent intent = getIntent();
        String message_text = intent.getStringExtra("message");
        String sender = intent.getStringExtra("sender");
        sms_anal(message_text, sender);
        //--------------------------------

//--------------------------- обработчик события нажатия кнопки
        imageButton_Query.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //
                Log.d(TAG, "Нажата кнопка Query");

                //проигрываем файл
                Play_Key_Pressed();

                if (CONNECTION_POSITION==0) try_sendSMS(Query);

                if(CONNECTION_POSITION==1) try_send_to_server(Query_server);

            }
        });

        //@Override
        //protected void onPostExecute(Void result) {
         //   textResponse.setText(response);
         //   super.onPostExecute(result);
        //}

//--------------------------- обработчик события нажатия кнопки
        imageButton_ON.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Log.d(TAG, "Нажата кнопка ARM ON");

                //проигрываем файл
                Play_Key_Pressed();

                if (checkBox_query.isChecked()) {
                    if (CONNECTION_POSITION == 0) try_sendSMS(Arm_on + "," + Query);
                    if (CONNECTION_POSITION == 1)
                        try_send_to_server(Arm_on + "," + Query_server);
                } else {
                    if (CONNECTION_POSITION == 0) try_sendSMS(Arm_on);
                    if (CONNECTION_POSITION == 1) try_send_to_server(Arm_on);
                }

            }
        });
//-------------------------------------------


//--------------------------- обработчик события нажатия кнопки
        imageButton_OFF.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Log.d(TAG, "Нажата кнопка ARM OFF");

                //проигрываем файл
                Play_Key_Pressed();

                if (checkBox_query.isChecked()) {
                    if (CONNECTION_POSITION == 0) try_sendSMS(Arm_off + "," + Query);
                    if (CONNECTION_POSITION == 1)
                        try_send_to_server(Arm_off + "," + Query_server);
                } else {
                    if (CONNECTION_POSITION == 0) try_sendSMS(Arm_off);
                    if (CONNECTION_POSITION == 1) try_send_to_server(Arm_off);
                }

            }
        });
//-------------------------------------------

        //******* fault click events
        imageView_power_.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_power_on.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_power_off.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_arm_.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_arm_on.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_arm_off.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_GSM_.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_GSM_high.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_GSM_medium.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_GSM_low.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_input_.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_input_norma.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });
        imageView_input_trevoga.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //проигрываем файл
                Play_Fault_Pressed();
            }
        });

//--------------------------- обработчик события нажатия кнопки
        checkBox_query.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                SharedPreferences.Editor editor = mSettings.edit();
                if (checkBox_query.isChecked()) {
                    editor.putString(APP_PREFERENCES_CHECK_BOX_QUERY, "check");
                } else {
                    editor.putString(APP_PREFERENCES_CHECK_BOX_QUERY, "uncheck");
                }
                editor.commit();
            }
        });
//-------------------------------------------

        //при старте считываем текущие IMEI и пароль
        if (mSettings.contains(APP_PREFERENCES_IMEI)) {
            IMEI = mSettings.getString(APP_PREFERENCES_IMEI, "");
        }

        if (mSettings.contains(APP_PREFERENCES_PASSWORD)) {
            PASSWORD = mSettings.getString(APP_PREFERENCES_PASSWORD, ini_password);
        }
        //--------------------------- выпадающий список способа управления
        String[] data_connection = {
                Connection_1,
                Connection_2};
        String temp;

        // адаптер
        ArrayAdapter<String> adapter_connection = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, data_connection);
        adapter_connection.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        Spinner spinner_connection = (Spinner) findViewById(R.id.spinner_connection);
        spinner_connection.setAdapter(adapter_connection);
        // заголовок
        spinner_connection.setPrompt("Список способов управления");

        btn_restart_connection.setBackgroundColor(COLOR_RED);

        // выделяем элемент
        spinner_connection.setSelection(0);

        if (mSettings.contains(APP_PREFERENCES_CONNECTION)) {
            temp = mSettings.getString(APP_PREFERENCES_CONNECTION, "sms");
            if (temp.equals("sms")) {
                spinner_connection.setSelection(0);
            }
            if (temp.equals("internet")) {
                spinner_connection.setSelection(1);
            }

        }



        // устанавливаем обработчик нажатия
        spinner_connection.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view,
                                       int position, long id) {
                // показываем позицию нажатого элемента
                //Toast.makeText(getBaseContext(), "Position = " + position, Toast.LENGTH_SHORT).show();
                SharedPreferences.Editor editor = mSettings.edit();
                String temp = mSettings.getString(APP_PREFERENCES_SERVICE, "0");
                CONNECTION_POSITION = position;
                switch (CONNECTION_POSITION) {
                    case 0:
                        editor.putString(APP_PREFERENCES_CONNECTION, "sms");
                        //STOP supervisor Service
                        if ( isMyServiceRunning(oko.tm.oko_s2.SupervisorService.class)) {
                            //STOP SERVICE
                            try {
                                stopService(new Intent(mContext, SupervisorService.class));

                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }

                        //STOP MY_SERVICE (tcp_client)
                        if ( isMyServiceRunning(oko.tm.oko_s2.MyService.class)) {

                            try {
                                stopService(new Intent(mContext, MyService.class));

                                try_send_to_server("");
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }



                        btn_restart_connection.setBackgroundColor(COLOR_RED);
                        editor.putString(APP_PREFERENCES_SERVICE, "0");
                        btn_restart_connection.setVisibility(View.INVISIBLE);
                        break;
                    case 1:
                        editor.putString(APP_PREFERENCES_CONNECTION, "internet");
                        //if ("0".equals(temp)) {



                        if ( ! isMyServiceRunning(oko.tm.oko_s2.MyService.class)) {
                            //START SERVICE TCP-SOCKET COMMUNICATION

                            try {
                                ClientThread.stopThread_periodic=false;
                                ClientThread.stopThread_client=false;
                            } catch (Exception e) {
                                e.printStackTrace();
                            }


                            new Thread(new Runnable() {
                                public void run() {
                                    try {
                                        startService(new Intent(mContext, MyService.class)); //запускаем сервис для работы через IP
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }

                                }
                            }).start();

                            new Thread(new Runnable() {
                                public void run() {
                                    try {
                                        startService(new Intent(mContext, SupervisorService.class)); //запускаем сервис для супервижинга IP-соединения
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }
                                }
                            }).start();

                            //startService(new Intent(mContext, MyService.class));
                            editor.putString(APP_PREFERENCES_SERVICE, "1");
                            /*
                            Thread.currentThread();
                            try {
                                Thread.sleep(1000);
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }

                            try_send_to_server(Query_server); //запрос состояния прибора
                            */
                            btn_restart_connection.setVisibility(View.VISIBLE);
                        }
                        break;

                }
                editor.commit();
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });




        //--------------------------------------------------------

//--------------------------- обработчик события нажатия кнопки
        btn_restart_connection.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!Service_Restart) {
                    btn_restart_connection.setBackgroundColor(COLOR_RED);
                    //проигрываем файл
                    Play_Key_Pressed();
                    new Thread(new Runnable() {
                        public void run() {
                            try {
                                Reset_Connection();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }

                        }
                    }).start();
                }
            }
        });
//-------------------------------------------------------

        //if (isMyServiceRunning(oko.tm.oko_s2.MyService.class)) try_send_to_server(Query_server);
        if (isMyServiceRunning(oko.tm.oko_s2.MyService.class)) try_send_to_server("");
    }


    //проверка запущен или нет сервис  - для проверки isMyServiceRunning(MyService.class)
    public boolean isMyServiceRunning(Class<?> serviceClass) {
        ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
            if (serviceClass.getName().equals(service.service.getClassName())) {
                return true;
            }
        }
        return false;
    }

    //reconnect to server
    private void Reset_Connection(){
        Service_Restart=true;
        //btn_restart_connection.setEnabled(false);
        try{
            //STOP supervisor service
            if ( isMyServiceRunning(oko.tm.oko_s2.SupervisorService.class)) {
                //STOP SERVICE
                try {
                    stopService(new Intent(mContext, SupervisorService.class));
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            //STOP MY_SERVICE (tcp-client)
            if ( isMyServiceRunning(oko.tm.oko_s2.MyService.class)) {

                Client_Thread_stop = false;
                Periodic_Thread_stop = false;
                stopService(new Intent(mContext, MyService.class));
                try_send_to_server("");
                int timeout = ClientThread.PERIODIC_QUERY+5;
                while (timeout != 0 && !(Client_Thread_stop && Periodic_Thread_stop)) {
                    Thread.currentThread();
                    try {
                        Thread.sleep(1000); //1 second
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    timeout--;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        //START SERVICE TCP-SOCKET COMMUNICATION
        try {
            ClientThread.stopThread_periodic=false;
            ClientThread.stopThread_client=false;
        } catch (Exception e) {
            e.printStackTrace();
        }
        new Thread(new Runnable() {
            public void run() {
                try {
                    startService(new Intent(mContext, MyService.class)); //запускаем сервис для работы через IP в отдельном потоке
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }).start();

        new Thread(new Runnable() {
            public void run() {
                try {
                    startService(new Intent(mContext, SupervisorService.class)); //запускаем сервис для супервижинга IP-соединения
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }).start();

        //startService(new Intent(mContext, MyService.class));

        //editor.putString(APP_PREFERENCES_SERVICE, "1");
        //btn_restart_connection.setEnabled(true);
        Service_Restart=false;
    }




    @Override
    protected void onResume() {
        // TODO Auto-generated method stub
        super.onResume();


        String temp;
        //-------------восстанавливаем сохраненные настройки, данные
        if (mSettings.contains(APP_PREFERENCES_PHONE)) {
            PHONE_NUMBER = mSettings.getString(APP_PREFERENCES_PHONE, "");
        }

        if (mSettings.contains(APP_PREFERENCES_IMEI)) {
            IMEI = mSettings.getString(APP_PREFERENCES_IMEI, "");
        }

        if (mSettings.contains(APP_PREFERENCES_PASSWORD)) {
            PASSWORD = mSettings.getString(APP_PREFERENCES_PASSWORD, ini_password);
        }

        if (mSettings.contains(APP_PREFERENCES_QUERY)) {
            textView_query.setText(mSettings.getString(APP_PREFERENCES_QUERY, update_time));
        }

        if (mSettings.contains(APP_PREFERENCES_POWER)) {
            textView_power.setText(mSettings.getString(APP_PREFERENCES_POWER, state_220v));
        }

        if (mSettings.contains(APP_PREFERENCES_ARM)) {
            textView_arm.setText(mSettings.getString(APP_PREFERENCES_ARM, state_arm));
        }

        if (mSettings.contains(APP_PREFERENCES_GSM)) {
            textView_gsm.setText(mSettings.getString(APP_PREFERENCES_GSM, gsm_level));
        }

        if (mSettings.contains(APP_PREFERENCES_INPUT)) {
            textView_input.setText(mSettings.getString(APP_PREFERENCES_INPUT, state_vxod));
        }
        if (mSettings.contains(APP_PREFERENCES_RELE)) {
            textView_rele.setText(mSettings.getString(APP_PREFERENCES_RELE, state_rele));
        }

        colour_io();

        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_POWER)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_POWER, "imageView_power_");
            imageView_power_.setVisibility(View.INVISIBLE);
            if (temp.equals("imageView_power_on")) {
                imageView_power_on.setVisibility(View.VISIBLE);
                imageView_power_off.setVisibility(View.INVISIBLE);
            }
            if (temp.equals("imageView_power_off")) {
                imageView_power_off.setVisibility(View.VISIBLE);
                imageView_power_on.setVisibility(View.INVISIBLE);
            }

        }

        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_ARM)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_ARM, "imageView_arm_");
            imageView_arm_.setVisibility(View.INVISIBLE);
            if (temp.equals("imageView_arm_on")) {
                imageView_arm_on.setVisibility(View.VISIBLE);
                imageView_arm_off.setVisibility(View.INVISIBLE);
            }
            if (temp.equals("imageView_arm_off")) {
                imageView_arm_off.setVisibility(View.VISIBLE);
                imageView_arm_on.setVisibility(View.INVISIBLE);
            }

        }


        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_GSM)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_GSM, "imageView_GSM_");
            imageView_GSM_.setVisibility(View.INVISIBLE);

            if (temp.equals("imageView_GSM_high")) {
                imageView_GSM_high.setVisibility(View.VISIBLE);
                imageView_GSM_medium.setVisibility(View.INVISIBLE);
                imageView_GSM_low.setVisibility(View.INVISIBLE);
            }

            if (temp.equals("imageView_GSM_medium")) {
                imageView_GSM_high.setVisibility(View.INVISIBLE);
                imageView_GSM_medium.setVisibility(View.VISIBLE);
                imageView_GSM_low.setVisibility(View.INVISIBLE);
            }

            if (temp.equals("imageView_GSM_low")) {
                imageView_GSM_high.setVisibility(View.INVISIBLE);
                imageView_GSM_medium.setVisibility(View.INVISIBLE);
                imageView_GSM_low.setVisibility(View.VISIBLE);
            }


        }



        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_INPUT)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_INPUT, "imageView_input_");
            imageView_input_.setVisibility(View.INVISIBLE);

            if (temp.equals("imageView_input_norma")) {

                imageView_input_norma.setVisibility(View.VISIBLE);
                imageView_input_trevoga.setVisibility(View.INVISIBLE);
            }

            if (temp.equals("imageView_input_trevoga")) {

                imageView_input_norma.setVisibility(View.INVISIBLE);
                imageView_input_trevoga.setVisibility(View.VISIBLE);
            }




        }

        if (mSettings.contains(APP_PREFERENCES_CHECK_BOX_QUERY)) {
            temp = mSettings.getString(APP_PREFERENCES_CHECK_BOX_QUERY, "check");
            checkBox_query.setChecked(false);
            if (temp.equals("check")) {
                checkBox_query.setChecked(true);
            }


        }



        //--------------------------- выпадающий список смс-команд
        String[] data = {
                Command_1,
                Command_2,
                Command_3};


        // адаптер
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, data);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        Spinner spinner = (Spinner) findViewById(R.id.spinner);
        spinner.setAdapter(adapter);
        // заголовок
        spinner.setPrompt("Список команд");
        // выделяем элемент
        spinner.setSelection(0);

        // устанавливаем обработчик нажатия
        spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view,
                                       int position, long id) {
                // показываем позиция нажатого элемента
                //Toast.makeText(getBaseContext(), "Position = " + position, Toast.LENGTH_SHORT).show();
                COMMAND_POSITION = position;
                switch (COMMAND_POSITION) {
                    case 0:

                        break;
                    case 1:

                        break;
                    case 2:

                        break;

                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });

        //--------------------------- обработчик события нажатия кнопки
        btn_send_command.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                //проигрываем файл
                Play_Key_Pressed();

                switch (COMMAND_POSITION) {
                    case 0:
                        if (checkBox_query.isChecked()) {
                            if (CONNECTION_POSITION == 0) try_sendSMS(SMS_Command_1 + "," + Query);
                            if (CONNECTION_POSITION == 1)
                                try_send_to_server(SMS_Command_1 + "," + Query_server);
                        } else {
                            if (CONNECTION_POSITION == 0) try_sendSMS(SMS_Command_1);
                            if (CONNECTION_POSITION == 1) try_send_to_server(SMS_Command_1);
                        }
                        break;
                    case 1:
                        if (checkBox_query.isChecked()) {
                            if (CONNECTION_POSITION == 0) try_sendSMS(SMS_Command_2 + "," + Query);
                            if (CONNECTION_POSITION == 1)
                                try_send_to_server(SMS_Command_2 + "," + Query_server);
                        } else {
                            if (CONNECTION_POSITION == 0) try_sendSMS(SMS_Command_2);
                            if (CONNECTION_POSITION == 1) try_send_to_server(SMS_Command_2);
                        }
                        break;

                    case 2:
                        if (checkBox_query.isChecked()) {
                            if (CONNECTION_POSITION == 0) try_sendSMS(SMS_Command_3);
                            if (CONNECTION_POSITION == 1) try_send_to_server(SMS_Command_3);
                        } else {
                            if (CONNECTION_POSITION == 0) try_sendSMS(SMS_Command_3);
                            if (CONNECTION_POSITION == 1) try_send_to_server(SMS_Command_3);
                        }
                        break;

                }

            }
        });

        //if (isMyServiceRunning(oko.tm.oko_s2.MyService.class)) try_send_to_server(Query_server); //запрос состояния прибора

        //--------------------------------------------------------

        ClientThread.MainActivity_Started=true;
        SmsReceiver.MainActivity_Started=true;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        //destroid application
        // дерегистрируем (выключаем) BroadcastReceiver
        //unregisterReceiver(br_tcp);
        LocalBroadcastManager.getInstance(mContext).unregisterReceiver(br_tcp);
        //unregisterReceiver(br_sms);
        LocalBroadcastManager.getInstance(mContext).unregisterReceiver(br_sms);
        ClientThread.MainActivity_Started=false;
        SmsReceiver.MainActivity_Started=false;
    }

    @Override
    public void onStop() {
        super.onStop();
        //hidden application
    }

    private void colour_io() {
        //colour inputs and outputs

        if ( textView_rele.getText().toString().indexOf(RELE_VKL)>-1 )
            textView_rele.setBackgroundColor (COLOR_GREEN); else textView_rele.setBackgroundColor(COLOR_WHITE);

        if (textView_input.getText().toString().indexOf(TREVOGA)>-1 )
            textView_input.setBackgroundColor (COLOR_RED); else textView_input.setBackgroundColor(COLOR_WHITE);
    }

    private void sms_anal(String message_text, String sender)
    {
        // --- анализируем входящую смс от GSM-розетки
        if (sender != null)
        {

            //проигрываем файл
            Play_Message();

            //-------------- System date
            StringBuilder msgDate = new StringBuilder("");
            Format formatter = new SimpleDateFormat("dd:MM:yyyy HH:mm:ss");
            msgDate.append(formatter.format(new Date()));

            //--------------------проверяем наличие статусной смс
            if (message_text.indexOf("GSM:") > -1) {
                //--- да, статусная - отображаем значения на элементах интерфейса
                textView_query.setText(update_time + msgDate);

                String imageView_power = "imageView_power_";
                if (message_text.indexOf(SMS_220V_ON) > -1) {
                    imageView_power = "imageView_power_on";
                    textView_power.setText(state_220v + EST);
                    imageView_power_on.setVisibility(View.VISIBLE);
                    imageView_power_off.setVisibility(View.INVISIBLE);
                    imageView_power_.setVisibility(View.INVISIBLE);
                }

                if (message_text.indexOf(SMS_220V_OFF) > -1) {
                    textView_power.setText(state_220v + NET);
                    imageView_power = "imageView_power_off";
                    imageView_power_off.setVisibility(View.VISIBLE);
                    imageView_power_on.setVisibility(View.INVISIBLE);
                    imageView_power_.setVisibility(View.INVISIBLE);
                }

                String imageView_arm = "imageView_arm_";
                if (message_text.indexOf(SMS_ARM_ON) > -1) {
                    textView_arm.setText(state_arm + VKL);
                    imageView_arm = "imageView_arm_on";
                    imageView_arm_on.setVisibility(View.VISIBLE);
                    imageView_arm_off.setVisibility(View.INVISIBLE);
                    imageView_arm_.setVisibility(View.INVISIBLE);

                }

                if (message_text.indexOf(SMS_ARM_OFF) > -1)  {
                    textView_arm.setText(state_arm + VYKL);
                    imageView_arm = "imageView_arm_off";
                    imageView_arm_off.setVisibility(View.VISIBLE);
                    imageView_arm_on.setVisibility(View.INVISIBLE);
                    imageView_arm_.setVisibility(View.INVISIBLE);

                }

                String imageView_GSM = "imageView_GSM_";
                if (message_text.indexOf(SMS_GSM_LEVEL_HIGH) > -1) {
                    textView_gsm.setText(gsm_level + VYSOKIJ);
                    imageView_GSM = "imageView_GSM_high";
                    imageView_GSM_high.setVisibility(View.VISIBLE);
                    imageView_GSM_medium.setVisibility(View.INVISIBLE);
                    imageView_GSM_low.setVisibility(View.INVISIBLE);
                    imageView_GSM_.setVisibility(View.INVISIBLE);
                }

                if (message_text.indexOf(SMS_GSM_LEVEL_MEDIUN) > -1) {
                    textView_gsm.setText(gsm_level + SREDNIJ);
                    imageView_GSM = "imageView_GSM_medium";
                    imageView_GSM_high.setVisibility(View.INVISIBLE);
                    imageView_GSM_medium.setVisibility(View.VISIBLE);
                    imageView_GSM_low.setVisibility(View.INVISIBLE);
                    imageView_GSM_.setVisibility(View.INVISIBLE);
                }

                if (message_text.indexOf(SMS_GSM_LEVEL_LOW) > -1) {
                    textView_gsm.setText(gsm_level + NIZKIJ);
                    imageView_GSM = "imageView_GSM_low";
                    imageView_GSM_high.setVisibility(View.INVISIBLE);
                    imageView_GSM_medium.setVisibility(View.INVISIBLE);
                    imageView_GSM_low.setVisibility(View.VISIBLE);
                    imageView_GSM_.setVisibility(View.INVISIBLE);
                }


                String imageView_input = "imageView_termo_";

                if (message_text.indexOf(SMS_ZONA_NORMA) > -1) {
                    textView_input.setText(state_vxod + NORMA);
                    imageView_input = "imageView_input_norma";
                    imageView_input_trevoga.setVisibility(View.INVISIBLE);
                    imageView_input_norma.setVisibility(View.VISIBLE);
                    imageView_input_.setVisibility(View.INVISIBLE);

                }

                if (message_text.indexOf(SMS_ZONA_TREVOGA) > -1) {
                    textView_input.setText(state_vxod + TREVOGA);
                    imageView_input = "imageView_input_trevoga";
                    imageView_input_trevoga.setVisibility(View.VISIBLE);
                    imageView_input_norma.setVisibility(View.INVISIBLE);
                    imageView_input_.setVisibility(View.INVISIBLE);

                }

                if (message_text.indexOf(SMS_ACC_LOW) > -1) {
                    textView_power.setText(textView_power.getText() + ", " + ACC_LOW);

                }

                if (message_text.indexOf(SMS_RELE_ON) > -1) {
                    textView_rele.setText(state_rele + RELE_VKL);

                }

                if (message_text.indexOf(SMS_RELE_OFF) > -1) {
                    textView_rele.setText(state_rele + RELE_VYKL);

                }

                colour_io();

                //------------------- сохраняем данные в файл
                String query = textView_query.getText().toString();
                String power = textView_power.getText().toString();
                String arm = textView_arm.getText().toString();
                String gsm = textView_gsm.getText().toString();
                String input = textView_input.getText().toString();
                String rele = textView_rele.getText().toString();


                SharedPreferences.Editor editor = mSettings.edit();

                editor.putString(APP_PREFERENCES_QUERY, query);
                editor.putString(APP_PREFERENCES_POWER, power);
                editor.putString(APP_PREFERENCES_ARM, arm);
                editor.putString(APP_PREFERENCES_GSM, gsm);
                editor.putString(APP_PREFERENCES_INPUT, input);
                editor.putString(APP_PREFERENCES_RELE, rele);

                editor.putString(APP_PREFERENCES_IMAGE_VIEW_POWER, imageView_power);
                editor.putString(APP_PREFERENCES_IMAGE_VIEW_ARM, imageView_arm);
                editor.putString(APP_PREFERENCES_IMAGE_VIEW_GSM, imageView_GSM);
                editor.putString(APP_PREFERENCES_IMAGE_VIEW_INPUT, imageView_input);
                //editor.apply();
                editor.commit();

            } else {
                // --- не статусная смс
                String TEXT;
                //---- замена текста - латиница на кирилицу
                TEXT=SMS_220V_ON;
                if (message_text.indexOf(TEXT) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(TEXT)) + state_220v + EST + message_text.substring(message_text.indexOf(TEXT) + TEXT.length(), message_text.length());

                TEXT=SMS_220V_OFF;
                if (message_text.indexOf(TEXT) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(TEXT)) + state_220v + NET + message_text.substring(message_text.indexOf(TEXT) + TEXT.length(), message_text.length());

                TEXT=SMS_ZONA_TREVOGA;
                if (message_text.indexOf(TEXT) > -1) {
                    message_text = message_text.substring(0, message_text.indexOf(TEXT)) + state_vxod + TREVOGA + message_text.substring(message_text.indexOf(TEXT) + TEXT.length(), message_text.length());
                    //проигрываем файл
                    Play_Alarm();
                }
                TEXT=SMS_ZONA_NORMA;
                if (message_text.indexOf(TEXT) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(TEXT)) + state_vxod + NORMA + message_text.substring(message_text.indexOf(TEXT) + TEXT.length(), message_text.length());

                TEXT=SMS_ACC_LOW;
                if (message_text.indexOf(TEXT) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(TEXT)) + ACC_LOW + message_text.substring(message_text.indexOf(TEXT) + TEXT.length(), message_text.length());

                //-------------вывод сообщения

                AlertDialog.Builder builder = new AlertDialog.Builder(mContext);
                builder.setTitle("SMS сообщение от OKO-S2")
                        .setMessage("Время: " + msgDate + "\n" + message_text)
                        .setIcon(R.drawable.ic_launcher)
                        .setCancelable(false)
                        .setNegativeButton("ОК",
                                new DialogInterface.OnClickListener() {
                                    public void onClick(DialogInterface dialog, int id) {
                                        dialog.cancel();
                                    }
                                }
                        );
                AlertDialog alert = builder.create();
                alert.show();
            }


        }
        //---------------------------------

    }




    //---try sends a SMS message ---
    private void try_sendSMS(String command) {

        String phoneNumber = PHONE_NUMBER;
        String password = PASSWORD;

        if (phoneNumber.length() > 0 && password.length() > 0)
        {
            sendSMS(phoneNumber, password + command);
        }   else {

            if (phoneNumber.length() == 0 && password.length() > 0)
                Toast.makeText(getBaseContext(),
                        Enter_Phone,
                        Toast.LENGTH_SHORT).show();
            else if (phoneNumber.length() > 0 && password.length() == 0)
                Toast.makeText(getBaseContext(),
                        Enter_Password,
                        Toast.LENGTH_SHORT).show();
            else

                Toast.makeText(getBaseContext(),
                        Enter_Phone_Password,
                        Toast.LENGTH_SHORT).show();

            // вызываем окно ввода настроек
            Intent intent = new Intent(MainActivity.this, SettingsActivity.class);
            startActivity(intent);
        }


    }


    //---sends a SMS message ---
    private void sendSMS(String phoneNumber, String message) {

        //----------------- таймер-сообщение
        AlertDialog.Builder builder = new AlertDialog.Builder(mContext);
        builder.setTitle("Выполнение команды")
                .setIcon(R.drawable.ic_launcher)
                .setMessage("Подождите пожалуйста...")
                .setCancelable(false);

        final AlertDialog dlg = builder.create();

        dlg.show();

        final Timer timer = new Timer();
        timer.schedule(new TimerTask() {
            public void run() {
                dlg.dismiss(); // when the task active then close the dialog
                timer.cancel(); // also just top the timer thread, otherwise,
                // you may receive a crash report
            }
        }, 3000); // через 3 секунд (3000 миллисекунд), the task will be active.
        //------------------------------------------



        String SENT = "COMMAND_SENT";
        String DELIVERED = "COMMAND_DELIVERED";

        PendingIntent sentPI = PendingIntent.getBroadcast(this, 0,
                new Intent(SENT), 0);

        PendingIntent deliveredPI = PendingIntent.getBroadcast(this, 0,
                new Intent(DELIVERED), 0);


        //---when the SMS has been sent---
        registerReceiver(new BroadcastReceiver() {
            @Override
            public void onReceive(Context arg0, Intent arg1) {
                switch (getResultCode()) {
                    case Activity.RESULT_OK:
                        Toast.makeText(getBaseContext(), "Команда отправлена",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_GENERIC_FAILURE:
                        Toast.makeText(getBaseContext(), "Generic failure",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_NO_SERVICE:
                        Toast.makeText(getBaseContext(), "No service",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_NULL_PDU:
                        Toast.makeText(getBaseContext(), "Null PDU",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_RADIO_OFF:
                        Toast.makeText(getBaseContext(), "Radio off",
                                Toast.LENGTH_SHORT).show();
                        break;
                }
            }
        }, new IntentFilter(SENT));


        //---when the SMS has been delivered---
        registerReceiver(new BroadcastReceiver() {
            @Override
            public void onReceive(Context arg0, Intent arg1) {
                switch (getResultCode()) {
                    case Activity.RESULT_OK:
                        Toast.makeText(getBaseContext(), "Команда доставлена",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case Activity.RESULT_CANCELED:
                        Toast.makeText(getBaseContext(), "Команда не доставлена",
                                Toast.LENGTH_SHORT).show();
                        break;
                }
            }
        }, new IntentFilter(DELIVERED));


        SmsManager sms = SmsManager.getDefault();
        sms.sendTextMessage(phoneNumber, null, message, sentPI, deliveredPI);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {

        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.menu_about) {
            Intent intent = new Intent(MainActivity.this, AboutActivity.class);
            startActivity(intent);
            return true;
        }

        if (id == R.id.menu_settings) {
            Intent intent = new Intent(MainActivity.this, SettingsActivity.class);
            startActivity(intent);
            return true;
        }

        return super.onOptionsItemSelected(item);


    }

    /*********************************************************************************
     *
     *          FOR IP CLIENT
     *
     ********************************************************************************/
    /*
    public static final Handler Parser = new Handler(){
        @Override
        public void handleMessage(Message msg)
        {
            //myTextView.setText("arg1 = " + msg.arg1 + "; arg2 = " + msg.arg2 + "; " + (String)msg.obj);
            if(msg.what == 1)
            {
                String data=(String)msg.obj;

                Log.d(TAG, data);
                if (data.startsWith("{"))
                {
                    DoParsing(data);

                }

            }

        }
    };
    */

    //---try sends a Command throw internet
    private void try_send_to_server(String command) {

        if (IMEI.length() > 0 && PASSWORD.length() > 0)
        {
            //ClientThread.send_to_server(command);
            try {
                Intent intent1 = new Intent(ClientThread.CLIENT_BROADCAST_RECIEVE_COMMAND);
                intent1.putExtra("command", command);
                //intent1.putExtra(PARAM_DATA, CONNECT_NO);
                //MyService.mContext.sendBroadcast(intent1);
                LocalBroadcastManager.getInstance(mContext).sendBroadcast(intent1);
            } catch (Exception e) {
                e.printStackTrace();
            }

        }   else {

            if (IMEI.length() == 0 && PASSWORD.length() > 0)
                Toast.makeText(getBaseContext(),
                        Enter_IMEI,
                        Toast.LENGTH_SHORT).show();
            else if (IMEI.length() > 0 && PASSWORD.length() == 0)
                Toast.makeText(getBaseContext(),
                        Enter_Password,
                        Toast.LENGTH_SHORT).show();
            else
                Toast.makeText(getBaseContext(),
                        Enter_IMEI_Password,
                        Toast.LENGTH_SHORT).show();

            // вызываем окно ввода настроек
            Intent intent = new Intent(mContext, SettingsActivity.class);
            startActivity(intent);
        }


    }

    public int hex2decimal(String s) {
        String digits = "0123456789ABCDEF";
        s = s.toUpperCase();
        int val = 0;
        for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            int d = digits.indexOf(c);
            val = 16*val + d;
        }
        return val;
    }

    public String hexToBin(String s) {
        return new BigInteger(s, 16).toString(2);
    }

    public String Bin_8bits(String state)
    {
        try {
            if (state.length()==1) {state="0000000".concat(state);}
            if (state.length()==2) {state="000000".concat(state);}
            if (state.length()==3) {state="00000".concat(state);}
            if (state.length()==4) {state="0000".concat(state);}
            if (state.length()==5) {state="000".concat(state);}
            if (state.length()==6) {state="00".concat(state);}
            if (state.length()==7) {state="0".concat(state);}
        }catch (Exception ex) {}
        return state;
    }

    private String Calc_T(int t)
    {
        String result="";
        try
        {
            if (t==128)
                result= "";
            else
            {
                if (t>125) t=(256-t)*(-1);
                result=Integer.toString(t);
            }
        }catch (Exception ex) {}

        return result;
    }

    private String Calc_RF_T(String input)
    {
        String result="";
        try
        {
            if (input.substring(3, 4).equals("A") || input.substring(3, 4).equals("E"))
                result=Calc_T(hex2decimal(input.substring(0, 2)));
        }catch (Exception ex) {}

        return result;
    }



    private void DoParsing(String request)
    {
        int max_num_sensors=50; //максимальное количество сенсоров прибора

        try {

            /* OKO-S2
             * {13227009840343,01,02,01F0,18,3.0.0,OKO-S2}
             * {866104020810332,F9,0B,05C8,1F,3.0.3,OKO-S2}
             * Termo&Humidity {866104020810332,F9,0B,05C8,1F,3.0.3,OKO-S2,12.4,56.8}
             *
             * {13227009840343,0036,0200,0F00,00B9,18,1918181819181818,CCF189FB000055FB18FA55FBA6FB000000000000000018EAEFABF1FB18EAF0BB,07690717000000000012001200120000,1.0.9,OKO-PRO}
             *OKO-U2
             *{863591021960863,00FF,0200,2F101000,0000,00,8080808080808080,0000000000000000000000000000000000000000000000000000000000000000,072D06E00000000000000FFB0FA40ABE0FFE0FFE0FFE0FFE0FFE0FFE0FFE0FFE,2.2.1_,OKO-U2,,}
             * {863591021960863,00FF,0200,2F101000,0000,00,8080808080808080,0000000000000000000000000000000000000000000000000000000000000000,072D06E00000000000000FFB0FA40ABE0FFE0FFE0FFE0FFE0FFE0FFE0FFE0FFE,2.2.1_,OKO-PRO,,}
             * */
            String[] requestParts = request.split(","); //data packet

            int num_fields=requestParts.length;

            //***************************************************************************
            //проверка протокола ТСР от прибора OKO-PRO

            if (num_fields>6)
            {

                if (requestParts[6].substring(0,6).equals("OKO-S2") )
                {
                    btn_restart_connection.setBackgroundColor(COLOR_GREEN);
                    //-------------- System date
                    StringBuilder msgDate = new StringBuilder("");
                    Format formatter = new SimpleDateFormat("dd:MM:yyyy HH:mm:ss");
                    msgDate.append(formatter.format(new Date()));



                    //IMEI
                    String device_code=requestParts[0].substring(1);

                    //event
                    int event_code=200;
                    try {
                        event_code=300+hex2decimal(requestParts[1]);
                        //Integer outputDecimal = Integer.parseInt(requestParts[12], 16); // actual conversion of hex to decimal
                    } catch (Exception ex) {}






                    //состояние входов, выходов, охраны, 220
                    String state_input=requestParts[2];

                    String est220="1";
                    String lowbat="0";
                    String ohrana="0";
                    String w_z1="1";
                    String w_z2="1";
                    String out1="0";
                    String out2="0";

                    //convert state from HEX to Binary
                    try {
                        state_input=hexToBin(state_input);
                        state_input=Bin_8bits(state_input);

                        //w_z8=state_input.substring(0,1);
                        ohrana=state_input.substring(1,2);
                        out2=state_input.substring(2,3);
                        out1=state_input.substring(3,4);
                        lowbat=state_input.substring(4,5);
                        est220=state_input.substring(5,6);
                        w_z2=state_input.substring(6,7);
                        w_z1=state_input.substring(7,8);
                    }catch (Exception ex) {}

                    // аналоговые показатели
                    Double opora=3.28;
                    String max_adc="0FFF";

                    String power=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[3]))/(double)(hex2decimal(max_adc)));



                    //gsm
                    int GSM_rssi=hex2decimal(requestParts[4]);
                    int GSM=0;
                    if (GSM_rssi>17)
                        GSM=3;
                    else
                    {
                        if (GSM_rssi>9) GSM=2; else {if (GSM_rssi>0) GSM=1; else GSM=0;}
                    }


                    //версия ПО
                    String version=requestParts[5];

                    //версия HW
                    String HW="";
                    if (num_fields==7)
                        HW=requestParts[6].substring(0, requestParts[6].length()-1);
                    else
                        HW=requestParts[6];

                    //температура
                    String temperature="";
                    if (num_fields>7) temperature=requestParts[7];

                    //влажность
                    String humidity="";
                    if (num_fields>8)
                    {
                        if (num_fields==9)
                            temperature=requestParts[8].substring(0, requestParts[8].length()-1);
                        else
                            temperature=requestParts[8];
                    }


                    /*
                    //состояние входов
                    String group=requestParts[2].substring(2,4);
                    String ohrana="0";
                    String groups="";
                    if (hex2decimal(group)!=0)
                    {
                        ohrana="1";
                        //convert state from HEX to Binary
                        try {
                            group=hexToBin(group);
                            group=Bin_8bits(group);
                            if (group.substring(7,8).equals("1")) groups=groups.concat("1,");
                            if (group.substring(6,7).equals("1")) groups=groups.concat("2,");
                            if (group.substring(5,6).equals("1")) groups=groups.concat("3,");
                            if (group.substring(4,5).equals("1")) groups=groups.concat("4,");
                            if (group.substring(3,4).equals("1")) groups=groups.concat("5,");
                            if (group.substring(2,3).equals("1")) groups=groups.concat("6,");
                            if (group.substring(1,2).equals("1")) groups=groups.concat("7,");
                            if (group.substring(0,1).equals("1")) groups=groups.concat("8");
                        }catch (Exception ex) {}

                    }

                    //состояние входов
                    String state_input=requestParts[3].substring(2,4);
                    String w_z1="1";
                    String w_z2="1";
                    String w_z3="1";
                    String w_z4="1";
                    String w_z5="1";
                    String w_z6="1";
                    String w_z7="1";
                    String w_z8="1";
                    //convert state from HEX to Binary
                    try {
                        state_input=hexToBin(state_input);
                        state_input=Bin_8bits(state_input);
                        w_z8=state_input.substring(0,1);
                        w_z7=state_input.substring(1,2);
                        w_z6=state_input.substring(2,3);
                        w_z5=state_input.substring(3,4);
                        w_z4=state_input.substring(4,5);
                        w_z3=state_input.substring(5,6);
                        w_z2=state_input.substring(6,7);
                        w_z1=state_input.substring(7,8);
                    }catch (Exception ex) {}

                    try {
                        if (requestParts[3].length()==8)
                        {
                            //if KZ
                            state_input=requestParts[3].substring(6,8);
                            state_input=hexToBin(state_input);
                            state_input=Bin_8bits(state_input);
                            if (state_input.substring(0,1).equals("1")) w_z8="2";
                            if (state_input.substring(1,2).equals("1")) w_z7="2";
                            if (state_input.substring(2,3).equals("1")) w_z6="2";
                            if (state_input.substring(3,4).equals("1")) w_z5="2";
                            if (state_input.substring(4,5).equals("1")) w_z4="2";
                            if (state_input.substring(5,6).equals("1")) w_z3="2";
                            if (state_input.substring(6,7).equals("1")) w_z2="2";
                            if (state_input.substring(7,8).equals("1")) w_z1="2";

                            //if OBRIV
                            state_input=requestParts[3].substring(4,6);
                            state_input=hexToBin(state_input);
                            state_input=Bin_8bits(state_input);
                            if (state_input.substring(0,1).equals("1")) w_z8="3";
                            if (state_input.substring(1,2).equals("1")) w_z7="3";
                            if (state_input.substring(2,3).equals("1")) w_z6="3";
                            if (state_input.substring(3,4).equals("1")) w_z5="3";
                            if (state_input.substring(4,5).equals("1")) w_z4="3";
                            if (state_input.substring(5,6).equals("1")) w_z3="3";
                            if (state_input.substring(6,7).equals("1")) w_z2="3";
                            if (state_input.substring(7,8).equals("1")) w_z1="3";
                        }
                    }catch (Exception ex) {}

                    //состояние 220, АКБ, тампер, литий-ион
                    String state=requestParts[3].substring(0,2);
                    String est220="1";
                    String lowbat="0";
                    String tamper="0";
                    String low_li_ion="0";
                    //convert state from HEX to Binary
                    try {
                        state=hexToBin(state);
                        state=Bin_8bits(state);
                        est220=state.substring(5,6);
                        lowbat=state.substring(4,5);
                        tamper=state.substring(3,4);
                        low_li_ion=state.substring(2,3);
                    }catch (Exception ex) {}

                    //состояние выходов
                    state=requestParts[4].substring(2,4);
                    String out1="0";
                    String out2="0";
                    String out3="0";
                    String out4="0";
                    String out5="0";
                    String out6="0";
                    String out7="0";
                    String out8="0";
                    //convert state from HEX to Binary
                    try {
                        state=hexToBin(state);
                        state=Bin_8bits(state);
                        out8=state.substring(0,1);
                        out7=state.substring(1,2);
                        out6=state.substring(2,3);
                        out5=state.substring(3,4);
                        out4=state.substring(4,5);
                        out3=state.substring(5,6);
                        out2=state.substring(6,7);
                        out1=state.substring(7,8);
                    }catch (Exception ex) {}


                    int GSM_rssi=hex2decimal(requestParts[5]);
                    int GSM=0;
                    if (GSM_rssi>17)
                        GSM=3;
                    else
                    {
                        if (GSM_rssi>9) GSM=2; else {if (GSM_rssi>0) GSM=1; else GSM=0;}
                    }

                    //температура адресных датчиков
                    String DS1820_1=Calc_T(hex2decimal(requestParts[6].substring(0,2)));
                    String DS1820_2=Calc_T(hex2decimal(requestParts[6].substring(2,4)));
                    String DS1820_3=Calc_T(hex2decimal(requestParts[6].substring(4,6)));
                    String DS1820_4=Calc_T(hex2decimal(requestParts[6].substring(6,8)));
                    String DS1820_5=Calc_T(hex2decimal(requestParts[6].substring(8,10)));
                    String DS1820_6=Calc_T(hex2decimal(requestParts[6].substring(10,12)));
                    String DS1820_7=Calc_T(hex2decimal(requestParts[6].substring(12,14)));
                    String DS1820_8=Calc_T(hex2decimal(requestParts[6].substring(14,16)));

                    //температура безпроводных датчиков
                    String rf_t_1=Calc_RF_T(requestParts[7].substring(0,4));
                    String rf_t_2=Calc_RF_T(requestParts[7].substring(4,8));
                    String rf_t_3=Calc_RF_T(requestParts[7].substring(8,12));
                    String rf_t_4=Calc_RF_T(requestParts[7].substring(12,16));
                    String rf_t_5=Calc_RF_T(requestParts[7].substring(16,20));
                    String rf_t_6=Calc_RF_T(requestParts[7].substring(20,24));
                    String rf_t_7=Calc_RF_T(requestParts[7].substring(24,28));
                    String rf_t_8=Calc_RF_T(requestParts[7].substring(28,32));
                    String rf_t_9=Calc_RF_T(requestParts[7].substring(32,36));
                    String rf_t_10=Calc_RF_T(requestParts[7].substring(36,40));
                    String rf_t_11=Calc_RF_T(requestParts[7].substring(40,44));
                    String rf_t_12=Calc_RF_T(requestParts[7].substring(44,48));
                    String rf_t_13=Calc_RF_T(requestParts[7].substring(48,52));
                    String rf_t_14=Calc_RF_T(requestParts[7].substring(52,56));
                    String rf_t_15=Calc_RF_T(requestParts[7].substring(56,60));
                    String rf_t_16=Calc_RF_T(requestParts[7].substring(60,64));

                    // аналоговые показатели
                    Double opora=3.28;
                    String max_adc="0FFF";

                    String power=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(0,4)))/(double)(hex2decimal(max_adc)));
                    String acc=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(4,8)))/(double)(hex2decimal(max_adc)));
                    String adc1=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(8,12)))/(double)(hex2decimal(max_adc)));
                    String adc2=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(12,16)))/(double)(hex2decimal(max_adc)));
                    String adc3=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(16,20)))/(double)(hex2decimal(max_adc)));
                    String ch0=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(20,24)))/(double)(hex2decimal(max_adc)));
                    String ch2=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(24,28)))/(double)(hex2decimal(max_adc)));
                    String ch3=String.format(Locale.ENGLISH,"%.1f",opora*10*(double)(hex2decimal(requestParts[8].substring(28,32)))/(double)(hex2decimal(max_adc)));

                    //версия ПО
                    String version=requestParts[9];

                    //версия HW
                    String HW="";
                    if (num_fields==11)
                        HW=requestParts[10].substring(0, requestParts[10].length()-1);
                    else
                        HW=requestParts[10];

                    //баланс
                    String balance="";
                    if (num_fields>11) balance=requestParts[11];

                    */


                    //отображаем значения на элементах интерфейса
                    textView_query.setText(update_time + msgDate);
                    String imageView_power = "imageView_power_";
                    if (est220.equals("1")) {
                        imageView_power = "imageView_power_on";
                        textView_power.setText(state_220v + EST);
                        imageView_power_on.setVisibility(View.VISIBLE);
                        imageView_power_off.setVisibility(View.INVISIBLE);
                        imageView_power_.setVisibility(View.INVISIBLE);
                    }

                    if (est220.equals("0")) {
                        textView_power.setText(state_220v + NET);
                        imageView_power = "imageView_power_off";
                        imageView_power_off.setVisibility(View.VISIBLE);
                        imageView_power_on.setVisibility(View.INVISIBLE);
                        imageView_power_.setVisibility(View.INVISIBLE);
                    }

                    String imageView_arm = "imageView_arm_";
                    if (ohrana.equals("1")) {
                        textView_arm.setText(state_arm + VKL);
                        imageView_arm = "imageView_arm_on";
                        imageView_arm_on.setVisibility(View.VISIBLE);
                        imageView_arm_off.setVisibility(View.INVISIBLE);
                        imageView_arm_.setVisibility(View.INVISIBLE);

                    }

                    if (ohrana.equals("0"))  {
                        textView_arm.setText(state_arm + VYKL);
                        imageView_arm = "imageView_arm_off";
                        imageView_arm_off.setVisibility(View.VISIBLE);
                        imageView_arm_on.setVisibility(View.INVISIBLE);
                        imageView_arm_.setVisibility(View.INVISIBLE);

                    }

                    String imageView_GSM = "imageView_GSM_";
                    if (GSM==3) {
                        textView_gsm.setText(gsm_level + VYSOKIJ);
                        imageView_GSM = "imageView_GSM_high";
                        imageView_GSM_high.setVisibility(View.VISIBLE);
                        imageView_GSM_medium.setVisibility(View.INVISIBLE);
                        imageView_GSM_low.setVisibility(View.INVISIBLE);
                        imageView_GSM_.setVisibility(View.INVISIBLE);
                    }

                    if (GSM==2) {
                        textView_gsm.setText(gsm_level + SREDNIJ);
                        imageView_GSM = "imageView_GSM_medium";
                        imageView_GSM_high.setVisibility(View.INVISIBLE);
                        imageView_GSM_medium.setVisibility(View.VISIBLE);
                        imageView_GSM_low.setVisibility(View.INVISIBLE);
                        imageView_GSM_.setVisibility(View.INVISIBLE);
                    }

                    if (GSM==1) {
                        textView_gsm.setText(gsm_level + NIZKIJ);
                        imageView_GSM = "imageView_GSM_low";
                        imageView_GSM_high.setVisibility(View.INVISIBLE);
                        imageView_GSM_medium.setVisibility(View.INVISIBLE);
                        imageView_GSM_low.setVisibility(View.VISIBLE);
                        imageView_GSM_.setVisibility(View.INVISIBLE);
                    }


                    String imageView_input = "imageView_termo_";

                    if (w_z1.equals("0")) {
                        textView_input.setText(state_vxod + NORMA);
                        imageView_input = "imageView_input_norma";
                        imageView_input_trevoga.setVisibility(View.INVISIBLE);
                        imageView_input_norma.setVisibility(View.VISIBLE);
                        imageView_input_.setVisibility(View.INVISIBLE);

                    }

                    if (w_z1.equals("1")) {
                        textView_input.setText(state_vxod + TREVOGA);
                        imageView_input = "imageView_input_trevoga";
                        imageView_input_trevoga.setVisibility(View.VISIBLE);
                        imageView_input_norma.setVisibility(View.INVISIBLE);
                        imageView_input_.setVisibility(View.INVISIBLE);

                    }

                    if (lowbat.equals("0")) {
                        textView_power.setText(textView_power.getText() + ", " + ACC_LOW);

                    }

                    if (out1.equals("1")) {
                        textView_rele.setText(state_rele + RELE_VKL);

                    }

                    if (out1.equals("0")) {
                        textView_rele.setText(state_rele + RELE_VYKL);

                    }

                    colour_io();

//------------------- сохраняем данные в файл
                    String query = textView_query.getText().toString();
                    String power_ = textView_power.getText().toString();
                    String arm = textView_arm.getText().toString();
                    String gsm = textView_gsm.getText().toString();
                    String input = textView_input.getText().toString();
                    String rele = textView_rele.getText().toString();


                    SharedPreferences.Editor editor = mSettings.edit();

                    editor.putString(APP_PREFERENCES_QUERY, query);
                    editor.putString(APP_PREFERENCES_POWER, power_);
                    editor.putString(APP_PREFERENCES_ARM, arm);
                    editor.putString(APP_PREFERENCES_GSM, gsm);
                    editor.putString(APP_PREFERENCES_INPUT, input);
                    editor.putString(APP_PREFERENCES_RELE, rele);

                    editor.putString(APP_PREFERENCES_IMAGE_VIEW_POWER, imageView_power);
                    editor.putString(APP_PREFERENCES_IMAGE_VIEW_ARM, imageView_arm);
                    editor.putString(APP_PREFERENCES_IMAGE_VIEW_GSM, imageView_GSM);
                    editor.putString(APP_PREFERENCES_IMAGE_VIEW_INPUT, imageView_input);
                    //editor.apply();
                    editor.commit();

                    //проигрываем файл
                    if (event_code!=549 && event_code!=550 && event_code!=540) {

                        String msg="";

                        //события по входу
                        if (event_code == 301 || event_code == 300)
                        {
                            msg=msg=textView_input.getText().toString();
                            if (event_code == 301) Play_Alarm(); else Play_Message();
                        }

                        //события постановка/снятие охраны
                        if ( event_code == 332 || event_code ==  333  )
                        {
                            msg=textView_arm.getText().toString();
                            Play_Message();
                        }

                        //события вкл/выкл выхода
                        if ( event_code == 340 || event_code ==  341  )
                        {
                            msg=textView_rele.getText().toString();
                            Play_Message();
                        }

                        //события по питанию
                        if ( event_code == 334 || event_code ==  335 || event_code ==  336 )
                        {
                            msg=textView_power.getText().toString();
                            Play_Message();
                        }


                        //событие запрос состояния
                        if ( event_code == 554 )
                        {
                            Play_Message();
                        }

                        //start
                        if ( event_code == 555 )
                        {
                            msg="Включение прибора";
                            Play_Message();
                        }

                        if (!msg.equals("")) {

                            //-------------вывод сообщения

                            AlertDialog.Builder builder = new AlertDialog.Builder(mContext);
                            builder.setTitle("Cообщение от OKO-S2!")
                                    .setMessage("Время: " + msgDate + "\n" + msg)
                                    .setIcon(R.drawable.ic_launcher)
                                    .setCancelable(false)
                                    .setNegativeButton("ОК",
                                            new DialogInterface.OnClickListener() {
                                                public void onClick(DialogInterface dialog, int id) {
                                                    dialog.cancel();
                                                }
                                            }
                                    );
                            AlertDialog alert = builder.create();
                            alert.show();
                        }
                    }


                    //long curTime = System.currentTimeMillis();
                    //String date_insert = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(curTime);
                    String date_insert=msgDate.toString(); //receiving server time

                    /*
                    //формируем массив сенсоров
                    String[] sensor_id = new String[max_num_sensors]; //код сенсора
                    String[] sensor_data_value = new String[max_num_sensors]; //значение сенсора
                    int sensors_num=0; //текущее значение сенсоров
                    int temp1=0;
                    try {
                        sensor_id[sensors_num]="30";  sensor_data_value[sensors_num++]= ohrana ; //ohrana
                        if (! groups.equals("")) {sensor_id[sensors_num]="133";  sensor_data_value[sensors_num++]= groups ;}
                        sensor_id[sensors_num]="10";  sensor_data_value[sensors_num++]= est220 ;
                        if (lowbat.equals("0")) {lowbat="1"; sensor_id[sensors_num]="62";  sensor_data_value[sensors_num++]= lowbat;}
                        if (est220.equals("1"))
                        {sensor_id[sensors_num]="29";  sensor_data_value[sensors_num++]= power;}
                        else
                        {
                            sensor_id[sensors_num]="139";  sensor_data_value[sensors_num++]= acc;
                            sensor_id[sensors_num]="29";  sensor_data_value[sensors_num++]= power;
                        }
                        if (low_li_ion.equals("0")) {low_li_ion="1"; sensor_id[sensors_num]="143";  sensor_data_value[sensors_num++]= low_li_ion;}

                        sensor_id[sensors_num]="17";  sensor_data_value[sensors_num++]= w_z1;
                        sensor_id[sensors_num]="18";  sensor_data_value[sensors_num++]= w_z2;
                        sensor_id[sensors_num]="19";  sensor_data_value[sensors_num++]= w_z3;
                        sensor_id[sensors_num]="20";  sensor_data_value[sensors_num++]= w_z4;

                        if (HW.equals("OKO-PRO"))
                        {
                            sensor_id[sensors_num]="21";  sensor_data_value[sensors_num++]= w_z5;
                            sensor_id[sensors_num]="22";  sensor_data_value[sensors_num++]= w_z6;
                            sensor_id[sensors_num]="23";  sensor_data_value[sensors_num++]= w_z7;
                            sensor_id[sensors_num]="24";  sensor_data_value[sensors_num++]= w_z8;
                        }

                        sensor_id[sensors_num]="116";  sensor_data_value[sensors_num++]= tamper;

                        sensor_id[sensors_num]="14";  sensor_data_value[sensors_num++]= out1;
                        sensor_id[sensors_num]="15";  sensor_data_value[sensors_num++]= out2;
                        sensor_id[sensors_num]="16";  sensor_data_value[sensors_num++]= out3;
                        sensor_id[sensors_num]="134";  sensor_data_value[sensors_num++]= out4;

                        if (HW.equals("OKO-PRO"))
                        {
                            sensor_id[sensors_num]="135";  sensor_data_value[sensors_num++]= out5;
                            sensor_id[sensors_num]="136";  sensor_data_value[sensors_num++]= out6;
                            sensor_id[sensors_num]="137";  sensor_data_value[sensors_num++]= out7;
                            sensor_id[sensors_num]="138";  sensor_data_value[sensors_num++]= out8;
                        }

                        sensor_id[sensors_num]="27";  sensor_data_value[sensors_num++]= adc1;
                        sensor_id[sensors_num]="28";  sensor_data_value[sensors_num++]= adc2;
                        sensor_id[sensors_num]="141";  sensor_data_value[sensors_num++]= adc3;

                        sensor_id[sensors_num]="85";  sensor_data_value[sensors_num++]= " ";

                        if (! DS1820_1.equals("")) {sensor_id[sensors_num]="53";  sensor_data_value[sensors_num++]= DS1820_1 ;}
                        if (! DS1820_2.equals("")) {sensor_id[sensors_num]="54";  sensor_data_value[sensors_num++]= DS1820_2 ;}
                        if (! DS1820_3.equals("")) {sensor_id[sensors_num]="55";  sensor_data_value[sensors_num++]= DS1820_3 ;}
                        if (! DS1820_4.equals("")) {sensor_id[sensors_num]="56";  sensor_data_value[sensors_num++]= DS1820_4 ;}
                        if (! DS1820_5.equals("")) {sensor_id[sensors_num]="57";  sensor_data_value[sensors_num++]= DS1820_5 ;}
                        if (! DS1820_6.equals("")) {sensor_id[sensors_num]="97";  sensor_data_value[sensors_num++]= DS1820_6 ;}
                        if (! DS1820_7.equals("")) {sensor_id[sensors_num]="98";  sensor_data_value[sensors_num++]= DS1820_7 ;}
                        if (! DS1820_8.equals("")) {sensor_id[sensors_num]="99";  sensor_data_value[sensors_num++]= DS1820_8 ;}

                        sensor_id[sensors_num]="84";  sensor_data_value[sensors_num++]= " ";

                        if (! rf_t_1.equals("")) {sensor_id[sensors_num]="100";  sensor_data_value[sensors_num++]= rf_t_1 ;}
                        if (! rf_t_2.equals("")) {sensor_id[sensors_num]="101";  sensor_data_value[sensors_num++]= rf_t_2 ;}
                        if (! rf_t_3.equals("")) {sensor_id[sensors_num]="102";  sensor_data_value[sensors_num++]= rf_t_3 ;}
                        if (! rf_t_4.equals("")) {sensor_id[sensors_num]="103";  sensor_data_value[sensors_num++]= rf_t_4 ;}
                        if (! rf_t_5.equals("")) {sensor_id[sensors_num]="104";  sensor_data_value[sensors_num++]= rf_t_5 ;}
                        if (! rf_t_6.equals("")) {sensor_id[sensors_num]="105";  sensor_data_value[sensors_num++]= rf_t_6 ;}
                        if (! rf_t_7.equals("")) {sensor_id[sensors_num]="106";  sensor_data_value[sensors_num++]= rf_t_7 ;}
                        if (! rf_t_8.equals("")) {sensor_id[sensors_num]="107";  sensor_data_value[sensors_num++]= rf_t_8 ;}
                        if (! rf_t_9.equals("")) {sensor_id[sensors_num]="108";  sensor_data_value[sensors_num++]= rf_t_9 ;}
                        if (! rf_t_10.equals("")) {sensor_id[sensors_num]="109";  sensor_data_value[sensors_num++]= rf_t_10 ;}
                        if (! rf_t_11.equals("")) {sensor_id[sensors_num]="110";  sensor_data_value[sensors_num++]= rf_t_11 ;}
                        if (! rf_t_12.equals("")) {sensor_id[sensors_num]="111";  sensor_data_value[sensors_num++]= rf_t_12 ;}
                        if (! rf_t_13.equals("")) {sensor_id[sensors_num]="112";  sensor_data_value[sensors_num++]= rf_t_13 ;}
                        if (! rf_t_14.equals("")) {sensor_id[sensors_num]="113";  sensor_data_value[sensors_num++]= rf_t_14 ;}
                        if (! rf_t_15.equals("")) {sensor_id[sensors_num]="114";  sensor_data_value[sensors_num++]= rf_t_15 ;}
                        if (! rf_t_16.equals("")) {sensor_id[sensors_num]="115";  sensor_data_value[sensors_num++]= rf_t_16 ;}

                        sensor_id[sensors_num]="60";  sensor_data_value[sensors_num++]= Integer.toString(GSM);
                        sensor_id[sensors_num]="140";  sensor_data_value[sensors_num++]= Integer.toString(GSM_rssi);
                        if (! balance.equals("")) {sensor_id[sensors_num]="11";  sensor_data_value[sensors_num++]= balance ;}
                        if (! version.equals("")) {sensor_id[sensors_num]="12";  sensor_data_value[sensors_num++]= version ;}
                        if (! HW.equals("")) {sensor_id[sensors_num]="142";  sensor_data_value[sensors_num++]= HW;}



                    }catch (Exception ex) {}

                    */


                    //save to DataBase
                    /*
                    String query = "SELECT account_id FROM objects WHERE device_code = '" + device_code + "'";
                    // executing SELECT query
                    rs_r = statement.executeQuery(query);
                    int account_id=-1;
                    if (rs_r.next()) {
                        account_id = rs_r.getInt(1);
                        //System.out.println("FOR TEST: account_id equals " + account_id+'.');
                    }
                    try { rs_r.close(); } catch(SQLException se) {  }

                    if (account_id==-1){
                        //прибор не введен ни под одним аккаунтом

                        if (event_code==254 || event_code==554){
                            //если запрос данных, то сохраняем под аккаунтом демо
                            account_id=1;
                        }else{
                            done=1;
                            //return done;
                        }

                    }
                    */

                    /*
                    if (done!=1)
                    {
                        String sat="";
                        String lat_f="";
                        String lon_f="";
                        String speed_f="";
                        String azimut_f="";
                        String gps_val="";

                        //query = "INSERT INTO `events`(`insert_date`,`device_code`,`event_code`,`account_id`,`row_data`) VALUES ('" + date_insert + "','" + device_code + "','" +event_code + "','" + account_id + "','" + request[0] + "')";
                        query = "INSERT INTO `events`(`insert_date`,`device_code`,`sat_number`,`lat`,`lon`, `speed`, `azimut`,`gps_validity`,`event_code`,`account_id`,`row_data`) VALUES ('" + date_insert + "','" + device_code + "','" + sat+ "','"+ lat_f + "','" + lon_f + "','" + speed_f + "','" + azimut_f + "','" + gps_val + "','" +event_code + "','" + account_id + "','" + request[0] + "')";


                        try {

                            // executing UPDATE query
                            statement.executeUpdate(query,Statement.RETURN_GENERATED_KEYS);
                            long insert_id=0;
                            rs_r = statement.getGeneratedKeys();
                            if (rs_r.next()){
                                insert_id=rs_r.getInt(1);
                            }
                            rs_r.close();

                            //сохраняем массив сенсоров
                            for (int i = 0; i < sensors_num; i++){
                                query = "INSERT INTO `events_details`(`event_id`,`sensor_id`,`data_value`) VALUES ('" + insert_id + "','" + sensor_id[i] + "','" + sensor_data_value[i] + "')";
                                statement.executeUpdate(query);
                            }

                        } catch (SQLException sqlEx) {
                            sqlEx.printStackTrace();
                        }catch(Exception e){
                            //Handle errors for Class.forName
                            e.printStackTrace();
                        } finally {
                            //close connection ,stmt and resultset here
                            //Print_Log("Data Base connection closed.",true);
                            //try { con.close(); } catch(SQLException se) {  }
                            //try { stmt.close(); } catch(SQLException se) {  }
                            //try { rs.close(); } catch(SQLException se) {  }
                        }

                        done=2;


                    }
                    */



                }
            }
        } catch (Exception ex)  {}


    }



    public void Play_Message() {

        new Thread(new Runnable() {
            public void run() {
                try {
                    MediaPlayer myMediaPlayer = null;
                    myMediaPlayer = MediaPlayer.create(mContext, R.raw.message);
                    myMediaPlayer.start();
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }).start();


    }

    public void Play_Alarm() {

        new Thread(new Runnable() {
            public void run() {
                try {
                    MediaPlayer myMediaPlayer = null;
                    myMediaPlayer = MediaPlayer.create(mContext, R.raw.alarm_2);
                    myMediaPlayer.start();
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }).start();


    }

    public void Play_Key_Pressed() {

        new Thread(new Runnable() {
            public void run() {
                try {
                    MediaPlayer myMediaPlayer = null;
                    myMediaPlayer = MediaPlayer.create(mContext, R.raw.kiss);
                    myMediaPlayer.start();
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }).start();


    }

    public void Play_Fault_Pressed() {

        new Thread(new Runnable() {
            public void run() {
                try {
                    MediaPlayer myMediaPlayer = null;
                    myMediaPlayer = MediaPlayer.create(mContext, R.raw.fault);
                    myMediaPlayer.start();
                } catch (Exception e) {
                    e.printStackTrace();
                }

            }
        }).start();


    }

}


